---
title: Request.clone()
slug: Web/API/Request/clone
tags:
  - API
  - Experimental
  - Fetch
  - Method
  - Reference
  - clone
  - request
---
<div>{{APIRef("Fetch")}}</div>

<p>The <strong><code>clone()</code></strong> method of the {{domxref("Request")}} interface creates a copy of the current <code>Request</code> object.</p>

<p><code>clone()</code> throws a {{jsxref("TypeError")}} if the response {{domxref("Body")}} has already been used. In fact, the main reason <code>clone()</code> exists is to allow multiple uses of {{domxref("Body")}} objects (when they are one-use only.)</p>

<p>If intend to modify the request, you may prefer the {{domxref("Request")}} constructor.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: js">var newRequest = request.clone();</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{domxref("Request")}} object, which is an exact copy of the <code>Request</code> that <code>clone()</code> was called on.</p>

<h2 id="Example">Example</h2>

<p>In the following snippet, we create a new request using the <code>{{domxref("Request.Request()")}}</code> constructor (for an image file in the same directory as the script), then clone the request.</p>

<pre class="brush: js">var myRequest = new Request('flowers.jpg');
var newRequest = myRequest.clone(); // a copy of the request is now stored in newRequest</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Fetch','#dom-request-clone','clone')}}</td>
   <td>{{Spec2('Fetch')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Request.clone")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Access_control_CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
